# Matt666 Juil. 2008

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

#Create a toolbar that easily toggle units
#V1.3

#Thanks to CadFather for the icons !! ^^ 
def toggle_units(int)
	model = Sketchup.active_model
	unitsOptions = model.options["UnitsOptions"]
	case int
		when 0,1,2,3,4
		unitsOptions["LengthUnit"] = int
		
		when 5,6,7,8
		result = int - 5
		case result
		when 1;unitsOptions["LengthUnit"] = 1
		when 2;unitsOptions["LengthUnit"] = 0
		when 3;unitsOptions["LengthUnit"] = 1
		end
		unitsOptions["LengthFormat"] = result
	end
	model.active_view.invalidate
	return nil
end

def toggle_units_validation_proc(int)
	unitsOptions = Sketchup.active_model.options["UnitsOptions"]
	case int
		when 0,1,2,3,4
		if unitsOptions["LengthFormat"] != 0
			return MF_GRAYED
		else
			if unitsOptions["LengthUnit"] == int
				return MF_CHECKED
			else
				return MF_UNCHECKED
			end
		end
		when 5,6,7,8
		result = int - 5
		if unitsOptions["LengthFormat"] == result
			return MF_CHECKED
		else
			return MF_UNCHECKED
		end
	end
end

if not file_loaded?("toggle_units.rb")
	u_menu = UI.menu("Plugins").add_submenu("Units")
		u_menu.add_item("Decimal") { toggle_units(5) }
		u_menu.add_item("Architectural") { toggle_units(6) }
		u_menu.add_item("Fractionnal") { toggle_units(7) }
		u_menu.add_item("Ingeniery") { toggle_units(8) }
		u_menu.add_separator
		u_menu.add_separator
		u_menu.add_item("Feet") { toggle_units(1) }
		u_menu.add_item("Inch") { toggle_units(0) }
		u_menu.add_separator
		u_menu.add_item("Millimeter") { toggle_units(2) }
		u_menu.add_item("Centimeter") { toggle_units(3) }
		u_menu.add_item("Meter") { toggle_units(4) }
	
	tb = UI::Toolbar.new("Units")
	
	ext = ".png"
	path = File.join("Plugins","toggle_units_icons")
	
	cmd = UI::Command.new("Decimal") { toggle_units(5) }
	cmd.small_icon = Sketchup.find_support_file(("tudec" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tudec" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Decimal"
	cmd.set_validation_proc { toggle_units_validation_proc(5) }
	tb.add_item(cmd)
	
	cmd = UI::Command.new("Architectural") { toggle_units(6) }
	cmd.small_icon = Sketchup.find_support_file(("tuarc" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tuarc" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Architectural"
	cmd.set_validation_proc { toggle_units_validation_proc(6) }
	tb.add_item(cmd)

	cmd = UI::Command.new("Fractionnal") { toggle_units(7) }
	cmd.small_icon = Sketchup.find_support_file(("tufra" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tufra" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Fractionnal"
	cmd.set_validation_proc { toggle_units_validation_proc(7) }
	tb.add_item(cmd)
	
	cmd = UI::Command.new("Ingeniery") { toggle_units(8) }
	cmd.small_icon = Sketchup.find_support_file(("tuing" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tuing" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Ingeniery"
	cmd.set_validation_proc { toggle_units_validation_proc(8) }
	tb.add_item(cmd)
	
	tb.add_separator
	tb.add_separator
	
	cmd = UI::Command.new("Inch") { toggle_units(0) }
	cmd.small_icon = Sketchup.find_support_file(("tuin" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tuin" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Inch"
	cmd.set_validation_proc { toggle_units_validation_proc(0) }
	tb.add_item(cmd)
	
	cmd = UI::Command.new("Feet") { toggle_units(1) }
	cmd.small_icon = Sketchup.find_support_file(("tufe" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tufe" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Feet"
	cmd.set_validation_proc { toggle_units_validation_proc(1) }
	tb.add_item(cmd)

	tb.add_separator
	
	cmd = UI::Command.new("Millmeter") { toggle_units(2) }
	cmd.small_icon = Sketchup.find_support_file(("tumm" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tumm" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Millimeter"
	cmd.set_validation_proc { toggle_units_validation_proc(2) }
	tb.add_item(cmd)
	
	cmd = UI::Command.new("Centimeter") { toggle_units(3) }
	cmd.small_icon = Sketchup.find_support_file(("tucm" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tucm" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Centimeter"
	cmd.set_validation_proc { toggle_units_validation_proc(3) }
	tb.add_item(cmd)
	
	cmd = UI::Command.new("Meter") { toggle_units(4) }
	cmd.small_icon = Sketchup.find_support_file(("tume" + "16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tume" + "24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Meter"
	cmd.set_validation_proc { toggle_units_validation_proc(4) }
	tb.add_item(cmd)
	
	state = tb.get_last_state 
	if(state == TB_NEVER_SHOWN)
		tb.show 
	elsif (state == TB_VISIBLE)
		tb.restore
	end
end
file_loaded("toggle_units.rb")
